// FL-PCI Cardp@`

// bZ[W TCD Code
#define BBR_REQ  65003
#define BBW_REQ  65004
#define BWR_REQ  65005
#define BWW_REQ  65006
#define NTR_REQ  65007
#define NTW_REQ  65008
#define STP_REQ  65009
#define RUN_REQ  65010
#define PFR_REQ  65011
#define LGR_REQ  65013
#define LGC_REQ  65014
#define LPB_REQ  65015

#define BBR_RSP  65203
#define BBW_RSP  65204
#define BWR_RSP  65205
#define BWW_RSP  65206
#define NTR_RSP  65207
#define NTW_RSP  65208
#define STP_RSP  65209
#define RUN_RSP  65210
#define PFR_RSP  65211
#define LGR_RSP  65213
#define LGC_RSP  65214
#define LPB_RSP  65215

// G[b
#define	PRM_ERR			2	// p^ G[
#define	BUF_FUL			3	// obt@ t
#define	NON_DATA		4	// f[^ Ȃ
#define	OUT_RING		5	// E
#define	TX_FAIL			6	// M s
#define TX_NOT_END		7   // M 
#define TIM_OUT			8	// ^CAEg
#define	FATAL_ERR		9	// dG[
#define DEV_ERR1		10	// foCXI[vG[1
#define DEV_ERR2		11	// foCXI[vG[2
#define DEV_ERR3		12	// foCXI[vG[3
#define DEV_ERR4		13	// foCXI[vG[4
#define DEV_NOT_OPEN	14	// foCXI[vȂ
#define DEV_ERR5		15	// foCXN[YG[
#define DEV_DUPL_OPEN   16  // foCXDuplicateI[v
#define NON_OTER_DEV    17  // Other Device Not Open
// }`vZXΉɂǉ
#define DEV_BUSY		18	// foCXBUSY
#define MUTEX_ERR       19	// rG[
#define LNK_DOWN        20	// P[uOɂ鏈


/////////////////////////////////////////////
// Library ֐ AvP[VI/F \
/////////////////////////////////////////////

// Qm[hvR}h\
struct SankaReqTable {
	unsigned char	node_cnt;   //  Qm[h
	unsigned char	node_no[254];// Qm[hmD
};


// lbg[NR}h\
struct NetInfo {
	unsigned short	rct;		// tbVTCN ݒl
	unsigned short	rcm;		// tbVTCN li݁j
	unsigned short	rcm_max;	// tbVTCN liőj
	unsigned short	rcm_min;	// tbVTCN liŏj
	unsigned char	link_status;// N̏
};

// dG[R}h \ 
struct ErrInfo {
	unsigned short	err_code;	// G[R[h
	unsigned short	length;		// bZ[W
	unsigned char	err_msg[128];// G[bZ[W
};

//  p^\
struct InitInfo {
	unsigned long	ip_adr;		// m[hhoAhX
	unsigned short  dev_no;     // foCXmD
	unsigned short	cmn1_adr;	// R ̈P AhX
	unsigned short	cmn1_size;	// R ̈P TCY
	unsigned short	cmn2_adr;	// R ̈Q AhX
	unsigned short	cmn2_size;	// R ̈Q TCY
	unsigned char	tw;			// g[NĎ^CAEgl
	unsigned char	mft;		// ŏt[Ԋu
	unsigned char	vender[11];	// x_
	unsigned char	maker[11];	// [J[
	unsigned char	name[11];	// m[h
};


// m[hv \
struct NodeInfo {
	unsigned char	sanka;		// Q^E tO
	unsigned short	uls;		// ʑwXe[^X
	unsigned short	cmn1_addr;	// R̈PAhX
	unsigned short	cmn1_size;	// R̈PTCY
	unsigned short	cmn2_addr;	// R̈QAhX
	unsigned short	cmn2_size;	// R̈QTCY
	unsigned short	rct;		// tbVTCNe
	unsigned char	tw;			// g[NĎ
	unsigned char	mft;		// ŏt[Ԋu
	unsigned char	link_status; // N̏
	unsigned char	my_status;	// m[h̏
	unsigned char	vender[11];	// x_[
	unsigned char	maker[11];	// [J[
	unsigned char	name[11];	// m[h
};

// bZ[WM \
struct MessageInfo {
	unsigned char	node;	// m[hԍ(1`254) 
	unsigned char	result; // ʃR[h
	unsigned long	tcd;	// gUNVR[h
	unsigned short	bc;		// bZ[Wf[^oCg
	unsigned long	addr;	// zAhX AhX
	unsigned short	length;	// zAhX f[^
};

// Om[h ULS & LKS \
struct UlsInfo {
	unsigned short uls[254];
	unsigned char  lks[254];
};

typedef unsigned char  uchar;
typedef unsigned int   uint;
typedef unsigned short ushort;
typedef unsigned long  ulong;
//
//FAnet Log Frame Format       
//must    FK{
//option  FґIIvV
//reservedF\AU[u
//free    F҂Cӂɒ`\ȗ̈
//
struct log_frame {
  struct {     /*MɊւ郍O*/
    ulong ulSendCount  ;/*must   M             */
    ulong ulSendErr    ;/*must   Ĉȉ̑Mװ*/
    ulong ulEthSendErr ;/*option ȯĂ̑Mװ  */
    ulong ulReserved3  ;/*reserved*/
    ulong ulReserved4  ;/*reserved*/
    ulong ulReserved5  ;/*reserved*/
    ulong ulRecvCount  ;/*must   M             */
    ulong ulRecvErr    ;/*must   Ĉȉ̎Mװ*/
    ulong ulEthRecvErr ;/*option ȯĂ̎Mװ  */
    ulong ulReserved9  ;/*reserved*/
    ulong ulReserved10 ;/*reserved*/
    ulong ulReserved11 ;/*reserved*/
  } Send_Recv;/*======================================*/
  struct {         /*t[M*/
    ulong ulSendToken  ;/*option İݑM   */
    ulong ulSendCyc    ;/*option دM */
    ulong ulSend1_1Msg ;/*option 1:1үޑM*/
    ulong ulSend1_NMsg ;/*option 1:NүޑM*/
    ulong ulReserved4  ;/*reserved*/
    ulong ulReserved5  ;/*reserved*/
    ulong ulRecvToken  ;/*option İݎM*/
    ulong ulRecvCyc    ;/*option دM*/
    ulong ulRecv1_1Msg ;/*option 1:1үގM*/
    ulong ulRecv1_NMsg ;/*option 1:NүގM*/
    ulong ulReserved10 ;/*reserved*/
    ulong ulReserved11 ;/*reserved*/
  } Frame;/*======================================*/
  struct {       /*د`̴װ*/
    ulong ulTotal      ;/*must   g[^*/
    ulong ulAd_Sz      ;/*option ڽ޴װ*/
    ulong ulCbn        ;/*option CBNװ*/
    ulong ulTbn        ;/*option TBNװ*/
    ulong ulBsize      ;/*option BSIZEװ*/
    ulong ulReserved5  ;/*reserved*/
    ulong ulReserved6  ;/*reserved*/
    ulong ulReserved7  ;/*reserved*/
    ulong ulReserved8  ;/*reserved*/
    ulong ulReserved9  ;/*reserved*/
    ulong ulReserved10 ;/*reserved*/
    ulong ulReserved11 ;/*reserved*/
  } Cyc_Err;/*======================================*/
  struct {        /*үޓ`̴װ*/
    ulong ulRetry      ;/*must   đ*/
    ulong ulRetryOver  ;/*must   đމ*/
    ulong usReserved2  ;/*reserved*/
    ulong ulReserved3  ;/*reserved*/
    ulong ulReserved4  ;/*reserved*/
    ulong ulReserved5  ;/*reserved*/
    ulong ulReserved6  ;/*reserved*/
    ulong ulRecvTotal  ;/*must   Mװ*/
    ulong ulTuban      ;/*option ʔԴװ*/
    ulong ulVersion    ;/*option đF*/
    ulong ulReserved10 ;/*reserved*/
    ulong ulReserved11 ;/*reserved*/
  } Msg_Err;/*======================================*/
  struct {       /*ACK֘A̴װ*/
    ulong ulTotal      ;/*must   ACKװ*/
    ulong ulVersion    ;/*option ްޮݥװ*/
    ulong ulTuban      ;/*option ʔԴװ*/
    ulong ulNodeNum    ;/*option ɰޔԍװ*/
    ulong ulTCD        ;/*option TCDװ*/
    ulong ulReserved5  ;/*reserved*/
    ulong ulReserved6  ;/*reserved*/
    ulong ulReserved7  ;/*reserved*/
    ulong ulReserved8  ;/*reserved*/
    ulong ulReserved9  ;/*reserved*/
    ulong ulReserved10 ;/*reserved*/
    ulong ulReserved11 ;/*reserved*/
  } Ack_Err;/*======================================*/
  struct {     /*İ݊֘A̴װ*/
    ulong ulTajyuka     ;/*must   İݑdF*/
    ulong ulHaki       ;/*must   İݔj*/
    ulong ulSaihakko   ;/*must   İݍĔs*/
    ulong ulReserved3  ;/*reserved*/
    ulong ulReserved4  ;/*reserved*/
    ulong ulReserved5  ;/*reserved*/
    ulong ulHojiTmOut  ;/*option İݕێѱĉ*/
    ulong ulKanshiTmOut;/*option İ݊Ďѱĉ*/
    ulong ulReserved8  ;/*reserved*/
    ulong ulReserved9  ;/*reserved*/
    ulong ulReserved10 ;/*reserved*/
    ulong ulReserved11 ;/*reserved*/
  } Token_Err;/*======================================*/
  struct {       /*ɰނ̏*/
    ulong ulTotalTm    ;/*option İىғ*/
    ulong ulFrameWait  ;/*must   ڰё҂Ԃ̉*/
    ulong ulKanyu      ;/*must   */
    ulong ulJikoRedatu ;/*must   ȗE (ɰނȂAێTm Out)*/
    ulong ulSkipRedatu ;/*must   ߗE(ɰވİ݂Ȃ)*/
    ulong ulOtherRedatu;/*must   ɰޗEF*/
    ulong ulReserved6  ;/*reserved*/
    ulong ulReserved7  ;/*reserved*/
    ulong ulReserved8  ;/*reserved*/
    ulong ulReserved9  ;/*reserved*/
    ulong ulReserved10 ;/*reserved*/
    ulong ulReserved11 ;/*reserved*/
  } Status;/*======================================*/
  struct {       /**/
    ulong ulNode0      ;/*Qɰވꗗ̂O*/
    ulong ulNode1      ;/*Qɰވꗗ̂P*/
    ulong ulNode2      ;/*Qɰވꗗ̂Q*/
    ulong ulNode3      ;/*Qɰވꗗ̂R*/
    ulong ulNode4      ;/*Qɰވꗗ̂S*/
    ulong ulNode5      ;/*Qɰވꗗ̂T*/
    ulong ulNode6      ;/*Qɰވꗗ̂U*/
    ulong ulNode7      ;/*Qɰވꗗ̂V*/
    ulong ulReserved8  ;/*reserved*/
    ulong ulReserved9  ;/*reserved*/
    ulong ulReserved10 ;/*reserved*/
    ulong ulReserved11 ;/*reserved*/
  } Status2;/*======================================*/

  struct {       /*\̈*/
    ulong ulReserved[16];/*reserved*/
  } Reserved;/*======================================*/
  struct {        /*Ғ`̈*/
    ulong ulReserved0  ;/*free    CӒ`\*/
    ulong ulReserved1  ;/*free    CӒ`\*/
    ulong ulReserved2  ;/*free    CӒ`\*/
    ulong ulReserved3  ;/*free    CӒ`\*/
    ulong ulReserved4  ;/*free    CӒ`\*/
    ulong ulReserved5  ;/*free    CӒ`\*/
    ulong ulReserved6  ;/*free    CӒ`\*/
    ulong ulReserved7  ;/*free    CӒ`\*/
    ulong ulReserved8  ;/*free    CӒ`\*/
    ulong ulReserved9  ;/*free    CӒ`\*/
    ulong ulReserved10 ;/*free    CӒ`\*/
    ulong ulReserved11 ;/*free    CӒ`\*/
    ulong ulReserved12 ;/*free    CӒ`\*/
    ulong ulReserved13 ;/*free    CӒ`\*/
    ulong ulReserved14 ;/*free    CӒ`\*/
    ulong ulReserved15 ;/*free    CӒ`\*/
  } Vender;
};

/* LINK status */
#define ERR_ADDR_OVERLAPED		0x80
#define COMMEM_SET_COMPLETE		0x40
#define COMMEM_DATA_VALID		0x20
#define UPL_SIG_ERR				0x10
#define INVALID_RING            0x02

/* UPL status */
#define UPL_WARNING				0x2000
#define UPL_ALARM				0x4000				
#define UPL_RUN					0x8000

/* My node_status bits */
#define ERR_NODE_OVERLAPED		0x80
#define ERR_TOKEN_WATCH_TIMEOUT	0x40
#define WAIT_RX_FRAME_STATE		0x20
#define ERR_MY_ADD2_OVERLAPED	0x10
#define ERR_MY_ADD1_OVERLAPED	0x08
#define ERR_INIT_PARAMETER		0x04
#define INIT_COMPLETE			0x02
#define NODE_NETWORK_SANKA		0x01


// Library ֐
extern "C" unsigned short __declspec(dllimport) __stdcall FL_Initialize(struct InitInfo *);
extern "C" unsigned short __declspec(dllimport) __stdcall WriteCyclicALL(unsigned short *, unsigned short *,   unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall WriteCyclicRelative(unsigned short,unsigned short,unsigned short,unsigned short *,  unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall ReadCyclicRelative(unsigned short,unsigned short,unsigned short,unsigned short,unsigned short *,  unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall ReadCyclicAbsolute(unsigned short,unsigned short,unsigned short,unsigned short *,  unsigned short); 
extern "C" unsigned short __declspec(dllimport) __stdcall ReadCyclicALL(unsigned short, unsigned short *, unsigned short *, unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall WriteMessage(struct MessageInfo *, unsigned char *, unsigned short  , unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall CheckMessageEnd(unsigned short *, unsigned short *,  unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall ReadMessage(struct MessageInfo *, unsigned char *, unsigned short  ,unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall GetRingInfo(struct SankaReqTable *,  unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall GetNodeInfo(unsigned short ,struct NodeInfo *,  unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall GetNetInfo(struct NetInfo *,  unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall GetLogInfo(unsigned long *,  unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall SetUplStatus(unsigned short  ,unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall GetErrInfo(struct ErrInfo *,  unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall DeviceClose(unsigned short, unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall DeviceOpen(unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall ReadUls_All(struct UlsInfo *,  unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall ReadCycAbsUls(unsigned short,unsigned short,unsigned short,unsigned short,unsigned short *,unsigned short *,struct UlsInfo *,unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall Dll_Version( void );
extern "C" unsigned short __declspec(dllimport) __stdcall Firmware_Version(unsigned short *, unsigned short);
extern "C" unsigned short __declspec(dllimport) __stdcall Set_Speed(unsigned long speed, unsigned short dev_no); /* 100Mbps 05/12/01 */
extern "C" unsigned short __declspec(dllimport) __stdcall Get_Speed(unsigned long *speed, unsigned long *duplex, unsigned short dev_no); /* 100Mbps 05/12/01 */

