//
// FLPCIsample.cpp : FL-net PCIJ[h TvAvP[VvO
// 1999.10.26 Century Systems 
//
#pragma pack(1)

#include "stdafx.h"
#include <wincon.h>
#include <stdio.h>
#include <string.h>

// G[b
#define	PRM_ERR			2	// p^ G[
#define	BUF_FUL			3	// obt@ t
#define	NO_DATA			4	// f[^ Ȃ
#define	OUT_RING		5	// E
#define	TX_FAIL			6	// M s
#define TX_NOT_END		7   // M 
#define TIM_OUT			8	// ^CAEg
#define	FATAL_ERR		9	// dG[
#define DEV_ERR1		10	// foCXI[vG[1
#define DEV_ERR2		11	// foCXI[vG[2
#define DEV_ERR3		12	// foCXI[vG[3
#define DEV_ERR4		13	// foCXI[vG[4
#define DEV_NOT_OPEN	14	// foCXI[vȂ
#define DEV_ERR5		15	// foCXN[YG[
#define DEV_DUPL_OPEN   16  // foCXDuplicateI[v
#define NON_OTER_DEV    17  // Other Device Not Open
// }`vZXΉɂǉ
#define DEV_BUSY		18	// foCXBUSY
#define MUTEX_ERR       19	// rG[
#define LNK_DOWN        20	// P[uOɂ鏈@06/03/26

// bZ[W TCD Code
#define BBR_REQ  65003
#define BBW_REQ  65004
#define BWR_REQ  65005
#define BWW_REQ  65006
#define NTR_REQ  65007
#define NTW_REQ  65008
#define STP_REQ  65009
#define RUN_REQ  65010
#define PFR_REQ  65011
#define LGR_REQ  65013
#define LGC_REQ  65014
#define LPB_REQ  65015

#define BBR_RSP  65203
#define BBW_RSP  65204
#define BWR_RSP  65205
#define BWW_RSP  65206
#define NTR_RSP  65207
#define NTW_RSP  65208
#define STP_RSP  65209
#define RUN_RSP  65210
#define PFR_RSP  65211
#define LPB_RSP  65215

/////////////////////////////////////////////
// Library ֐ AvP[VI/F \
/////////////////////////////////////////////

// Qm[hvR}h\
struct SankaReqTable {
	unsigned char	node_cnt;   //  Qm[h
	unsigned char	node_no[254];// Qm[hmD
};


// lbg[NR}h\
struct NetInfo {
	unsigned short	rct;		// tbVTCN ݒl
	unsigned short	rcm;		// tbVTCN li݁j
	unsigned short	rcm_max;	// tbVTCN liőj
	unsigned short	rcm_min;	// tbVTCN liŏj
	unsigned char	link_status;// N̏
};

// dG[R}h \ 
struct ErrInfo {
	unsigned short	err_code;	// G[R[h
	unsigned short	length;		// bZ[W
	unsigned char	err_msg[128];// G[bZ[W
};

//  p^\
struct InitInfo {
	unsigned long	ip_adr;		// m[hhoAhX
	unsigned short  dev_no;     // foCXmD
	unsigned short	c1_adr;		// R ̈P AhX
	unsigned short	c1_size;	// R ̈P TCY
	unsigned short	c2_adr;		// R ̈Q AhX
	unsigned short	c2_size;	// R ̈Q TCY
	unsigned char	tw;			// g[NĎ^CAEgl
	unsigned char	mft;		// ŏt[Ԋu
	unsigned char	vender[11];	// x_
	unsigned char	maker[11];	// [J[
	unsigned char	name[11];	// m[h
};


// m[hv \
struct NodeInfo {
	unsigned char	sanka;		// Q^E tO
	unsigned short	uls;		// ʑwXe[^X
	unsigned short	cmn1_addr;	// R̈PAhX
	unsigned short	cmn1_size;	// R̈PTCY
	unsigned short	cmn2_addr;	// R̈QAhX
	unsigned short	cmn2_size;	// R̈QTCY
	unsigned short	rct;		// tbVTCNe
	unsigned char	tw;			// g[NĎ
	unsigned char	mft;		// ŏt[Ԋu
	unsigned char	link_status; // N̏
	unsigned char	my_status;	// m[h̏
	unsigned char	vender[11];	// x_[
	unsigned char	maker[11];	// [J[
	unsigned char	name[11];	// m[h
};

// bZ[WM \
struct MessageInfo {
	unsigned char	msg_node;	// m[hԍ(1`254) 
	unsigned char	msg_result; // ʃR[h
	unsigned long	msg_tcd;	// gUNVR[h
	unsigned short	msg_bc;		// bZ[Wf[^oCg
	unsigned long	msg_adr;	// zAhX AhX
	unsigned short	msg_lng;	// zAhX f[^
};

// Om[h ULS & LKS \
struct UlsInfo {
	unsigned short uls[254];
	unsigned char  lks[254];
};

////////////////////////////////////////
// AvP[V O[oϐ
////////////////////////////////////////
//m[h
unsigned short      my_node;
unsigned short      dev_no;
struct NodeInfo		node_prm;
// TCNbNf[^\p ҏWobt@]
unsigned short		 dsp_buf1[512];
unsigned short		 dsp_buf2[16*512];

// O obt@
unsigned long		log_buf[128];

// 
unsigned char		msg_buf[1024];

// O[oϐ : FL-net PCIJ[h bZ[WǗ
// LOOP BACK TEST : bZ[WM e[u
#define MSG_SND_MAX		2
#define MSG_RCV_MAX		6
struct  MessageInfo  msnd_tbl[MSG_SND_MAX];
struct  MessageInfo  mrcv_tbl[MSG_RCV_MAX];
unsigned char		 msnd_buf[MSG_SND_MAX][1024];
unsigned char		 mrcv_buf[MSG_RCV_MAX][1024];
unsigned short	msnd_cnt;
unsigned short	mrcv_cnt;
unsigned short	msnd_st_pnt;
unsigned short	msnd_tx_pnt;
unsigned short	mrcv_st_pnt;
unsigned short	mrcv_tx_pnt;


//extern "C" DWORD __declspec(dllimport) __stdcall FLC_init(DWORD dev_no);
// [J֐̃vg^Cv錾
short Initialize(void);
void WriteCyc(void);
void WriteCyc_R(void);
void ReadCyc_R(void);
void ReadCyc_A(void);
void ReadCyc_AL(void);
void RingInfo(void);
void DspNodeInfo(void);
void DspNetInfo(void);
void DspLogInfo(void);
void UplStatus(void);
void DspFatalErr(void);
void MsgSendReceive();
void WriteMsg(unsigned short);
void CheckMsg(unsigned short);
void ReadMsg(unsigned short);
void MessageLoopBack(unsigned short);
void DevOpn(void);
void DevCls(void);
void AllCycUls(void);
void UlsLks(void);
void Firmware_ver_dsp();
void DspEtherMode();   /* 100Mbps support 06/03/26 */
//void RUNTEST(void);

// Library ֐
extern "C"unsigned short __declspec(dllimport) __stdcall FL_Initialize(struct InitInfo *);
extern "C"unsigned short __declspec(dllimport) __stdcall WriteCyclicALL(unsigned short *, unsigned short *,   unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall WriteCyclicRelative(unsigned short,unsigned short,unsigned short,unsigned short *,  unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall ReadCyclicRelative(unsigned short,unsigned short,unsigned short,unsigned short,unsigned short *,  unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall ReadCyclicAbsolute(unsigned short,unsigned short,unsigned short,unsigned short *,  unsigned short); 
extern "C"unsigned short __declspec(dllimport) __stdcall ReadCyclicALL(unsigned short, unsigned short *, unsigned short *, unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall WriteMessage(struct MessageInfo *, unsigned char *, unsigned short  , unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall CheckMessageEnd(unsigned short *, unsigned short *,  unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall ReadMessage(struct MessageInfo *, unsigned char *, unsigned short  ,unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall GetRingInfo(struct SankaReqTable *,  unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall GetNodeInfo(unsigned short ,struct NodeInfo *,  unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall GetNetInfo(struct NetInfo *,  unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall GetLogInfo(unsigned long *,  unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall SetUplStatus(unsigned short  ,unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall GetErrInfo(struct ErrInfo *,  unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall DeviceClose(unsigned short, unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall DeviceOpen(unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall ReadUls_All(struct UlsInfo *,  unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall ReadCycAbsUls(unsigned short,unsigned short,unsigned short,unsigned short,unsigned short *,unsigned short *,struct UlsInfo *,unsigned short);
extern "C"unsigned short __declspec(dllimport) __stdcall Dll_Version( void );
extern "C"unsigned short __declspec(dllimport) __stdcall Firmware_Version(unsigned short *, unsigned short);  /* 04/04/06 */
extern "C"unsigned short __declspec(dllimport) __stdcall Set_Speed(unsigned long speed, unsigned short dev_no); /* 100Mbps 06/03/26 */
extern "C"unsigned short __declspec(dllimport) __stdcall Get_Speed(unsigned long *speed, unsigned long *duplex, unsigned short dev_no); /* 100Mbps 06/03/26 */
//
// Console Event Execute
//
BOOL WINAPI HandlerRoutine(DWORD dwCtrlType)
{

	switch(dwCtrlType)
	{
	case CTRL_C_EVENT:
		break;
	case CTRL_BREAK_EVENT:
		break;
	case CTRL_CLOSE_EVENT:
        /*ClearDev(dev_no);*/
		DeviceClose(dev_no, 0);
		break;
	case CTRL_LOGOFF_EVENT:
		break;
	case CTRL_SHUTDOWN_EVENT:
		break;
	}

	return FALSE; /*TRUE;*/

}

//
// main
//
void main(long argc, char* argv[])
{
	int   number;
	short r_code;

	dev_no = 0xff;
	printf("FLPCIsample - FL-net PCIJ[h(100Mbps) TvAvP[VvO\n");
	printf("Copyright (C) Century Systems, 2006\n");
	printf("\n");

	// {^
	SetConsoleCtrlHandler(HandlerRoutine,TRUE);

	// FL-net PCIJ[hB
	while (1) {
		if(dev_no == 0xff)	printf("\n<<<<<<<<< Test Menue(Dev No.?? ) <<<<<<<<<<\n");
		else  		        printf("\n<<<<<<<<< Test Menue(Dev No.%d) <<<<<<<<<<\n",dev_no);
		printf("0)  initialize\n");
		printf("1)  Write cyclic data(all)\n");
		printf("2)  Write cyclic data(relative offset)\n");
		printf("3)  Read cyclic data (relative offset)\n");
		printf("4)  Read cyclic data (absolute offset)\n");
		printf("5)  Read cyclic data (all)\n");
		printf("6)  bZ[WM\n");
		printf("7)  Qm[h\\n");
		printf("8)  m[h \\n");
		printf("9)  lbg[N \\n");
		printf("10)  O \\n");
		printf("11) ʑwXe[^X w\n");
		printf("12) dG[ڍ \\n");
        printf("13) foCX I[v\n");
        printf("14) foCX N[Y\n");
        printf("15) ULS LKS\\n");
        printf("16) DLL Version\\n");
        printf("17) Firmware Version\\n");
        printf("18) FL-PCI Card̒ʐMx̕\\n");  /* 100Mbps support 06/03/26 */
		printf("19) I\n");
		printf("Enter number : ");
		scanf("%d", &number);
		switch(number){
		case 0:
			r_code = Initialize();
			break;
		case 1:
			WriteCyc();
			break;
		case 2:
			WriteCyc_R();
			break;
		case 3:
			ReadCyc_R();
			break;
		case 4:
			ReadCyc_A();
			break;
		case 5:
			ReadCyc_AL();
			break;
		case 6:
			//MessageLoopBack();
			MsgSendReceive();
			break;
		case 7:
			RingInfo();
			break;
		case 8:
			DspNodeInfo();
			break;
		case 9:
			DspNetInfo();
			break;
		case 10:
			DspLogInfo();
			break;
		case 11:
			UplStatus();
			break;
		case 12:
			DspFatalErr();
			break;
        case 13:
			DevOpn();
			break;
        case 14:
			DevCls();
			break;
        case 15:
            UlsLks();
			break;
		case 16:
			printf("\nDLL Version = %d\n",Dll_Version() );  
			break;
		case 17:
			Firmware_ver_dsp();
			break;
		case 18:
			DspEtherMode();  /* 100Mbps support 06/03/26 */
			break;
		case 19:
			return;
		default:
			break;
		}
	}

}

//
// Initialize : FL-net PCIJ[hB
//
// RETURN CODE
//   0 : 
//  -1 : s
//
short Initialize(void)
{
	struct	InitInfo	init_prm;
	unsigned short		rc;
	unsigned int		mft,tw,temp;
	unsigned long       speed;

	// foCXmD͂B
	do {
		printf("foCXmDw肵ĂiDecj\n");
		scanf("%x", &dev_no);
	} while ( 0 > dev_no || 4 <= dev_no );
	init_prm.dev_no = dev_no;

	// hoAhX͂B
	printf("hoAhXw肵ĂiHexj : ");
	scanf("%x", &init_prm.ip_adr);
	my_node = (unsigned short)(init_prm.ip_adr & 0x000000ff);

	// ̈P̃AhX͂B
	do {
		printf("R̈P AhXw肵ĂiDecj\n");
		scanf("%d", &temp);
	} while ( 512 <= temp );
	init_prm.c1_adr = (unsigned short)temp;

	// ̈P̃TCY͂B
	do {
		printf("R̈P TCYw肵ĂiDecj\n");
		scanf("%d", &temp);
	} while ( 512 < init_prm.c1_adr + temp );
	init_prm.c1_size = (unsigned short)temp;

	// ̈Q̃AhX͂B
	do {
		printf("R̈Q AhXw肵ĂiDecj\n");
		scanf("%d", &temp);
	} while ( 8192 <= temp );
	init_prm.c2_adr = (unsigned short)temp;

	// ̈Q̃TCY͂B
	do {
		printf("R̈Q TCYw肵ĂiDecj\n");
		scanf("%d", &temp);
	} while ( 8192 < init_prm.c2_adr + temp );
	init_prm.c2_size = (unsigned short)temp;

	// g[NĎԂ͂B
	do {
		printf("g[NĎԂw肵ĂiDecj\n");
		scanf("%d", &tw);
	} while ( 255 < tw || tw==0 );
	init_prm.tw = (unsigned char)tw;

	// ŏt[Ԋu͂B
	do {
		printf("ŏt[Ԋuw肵ĂiDecj\n");
		scanf("%d", &mft);
	} while ( 50 < mft );
	init_prm.mft = (unsigned char)mft;

	// x_[͂B
	memset(&init_prm.vender, 0, 10);
	printf("x_[͂ĂiPOȓj\n");
	scanf("%s", &init_prm.vender);

	// [J[͂B
	memset(&init_prm.maker, 0, 10);
	printf("[J[͂ĂiPOȓj\n");
	scanf("%s", &init_prm.maker);

	// m[h͂B
	memset(&init_prm.name, 0, 10);
	printf("m[h͂ĂiPOȓj\n");
	scanf("%s", &init_prm.name);

	/* EthernetʐMxݒ肷  100Mbps support 06/03/26 */
	do {
		printf("ʐMxIĂ@0:10Mbps 1:100Mbps 2:I\n");
		scanf("%d", &speed);
	} while ( 2 < speed);

    rc = Set_Speed(speed, dev_no);
	switch(rc){
	case 0:
		break;
	case PRM_ERR:
		printf("[Set_Speed] p^G[@\n");
		return(-1);
	default:
		printf("[Set_Speed] Other Error=%d", rc);
		return(-1);
	}

	rc =  FL_Initialize(&init_prm);
	if(rc > 0){
		switch(rc){
		case PRM_ERR:
			printf("p^G[\n");
			break;
		case TIM_OUT:
			printf("obh̃X|X ^CAEg\n");
			break;
		case FATAL_ERR:
			printf("dG[\n");
			break;
		case DEV_ERR1:
			printf("CreateFile() failed.\n");
			break;
		case DEV_ERR2:
			printf("DeviceIoControl() failed.\n");
			break;
		case DEV_ERR3:
			printf("pnpci == 0\n");
			break;
        case DEV_DUPL_OPEN:
			printf("Duplicate Open Error\n");
			break;
		case DEV_BUSY:
			printf("̃foCXOPENĂ܂\n");
			break;
		case MUTEX_ERR:
			printf("MUTEX擾ŃG[܂\n");
            break;
		default:
			printf("[Device open] Other Error=%d\n",rc);
			break;
		}
		return(-1);
	}
	else{
		printf("[Initialize] PCI card initialize completed.\n");
        
		//ȍ~̏Ŏm[hݒlgp邽߁Am[h荞
#if 0 // 2014/11/05 
	    rc = GetNodeInfo(my_node, &node_prm, dev_no);
#else
		do {
			rc = GetNodeInfo(my_node, &node_prm, dev_no);
			Sleep(1000);
		} while ((node_prm.my_status & 0x02) == 0);
#endif
	    if(rc > 0){
		    switch(rc){
		    case PRM_ERR:
			    printf("p^G[\n");
			    break;
		    case TIM_OUT:
			    printf("obh̃X|X ^CAEg\n");
			    break;
		    case FATAL_ERR:
			    printf("dG[\n");
			    break;
	        case DEV_NOT_OPEN:
		        printf("wfoCX͂nĂ܂\n");
		        break;
	        case MUTEX_ERR:
		        printf("MUTEXrG[܂\n");
                break;
	        default:
		        printf("[GetNodeInfo] Other Error=%d\n",rc);
		        break;
			}
		    return(-1);
		}
		return(0);
	}
}

// 
//
//
void DevOpn(void)
{
	unsigned short		rc;


	// foCXmD͂B
	do {
		printf("foCXmDw肵ĂiDecj\n");
		scanf("%d", &dev_no);
	} while ( 4 <= dev_no );

    rc = DeviceOpen(dev_no);
	if(rc > 0){
		switch(rc){
		case PRM_ERR:
			printf("p^G[\n");
			break;
		case TIM_OUT:
			printf("obh̃X|X ^CAEg\n");
			break;
		case FATAL_ERR:
			printf("dG[\n");
			break;
		case DEV_ERR1:
			printf("CreateFile() failed.\n");
			break;
		case DEV_ERR2:
			printf("DeviceIoControl() failed.\n");
			break;
		case DEV_ERR3:
			printf("pnpci == 0\n");
			break;
        case DEV_DUPL_OPEN:
			printf("Duplicate Open Error\n");
			break;
        case NON_OTER_DEV:
			printf("Other Device Not Open\n");
			break;
		case MUTEX_ERR:
			printf("MUTEX擾ŃG[܂\n");
            break;
		default:
			printf("[Device open] Other Error=%d\n",rc);
			break;

		}
		return;
	}
	else{
		printf("[Device open] Device Open completed.\n");

	    // m[hԍ𓾂B
	    do {
		    printf("m[h̃m[hNo.iIPAhX4ځj͂Ă  : ");
		    scanf("%d", &my_node);
		} while (my_node < 1 || 254 < my_node);

		//ȍ~̏Ŏm[hݒlgp邽߁Am[h荞
	    rc = GetNodeInfo(my_node, &node_prm, dev_no);
	    if(rc > 0){
		    switch(rc){
		    case PRM_ERR:
			    printf("p^G[\n");
			    break;
		    case TIM_OUT:
			    printf("obh̃X|X ^CAEg\n");
			    break;
		    case FATAL_ERR:
			    printf("dG[\n");
			    break;
	        case DEV_NOT_OPEN:
		        printf("wfoCX͂nĂ܂\n");
		        break;
	        case MUTEX_ERR:
		        printf("MUTEXrG[܂\n");
                break;
	        default:
		        printf("[GetNodeInfo] Other Error=%d\n",rc);
		        break;
			}
		    return;
		}
	}

}

// 
//
//
void DevCls(void)
{
	unsigned short		rc;
	unsigned int		reset_f;


	// RESETw͂B
	do {
		printf("RESET(0:NOT RESET ,1:RESET)w肵ĂiDecj\n");
		scanf("%d", &reset_f);
	} while ( 1 < reset_f );

    rc = DeviceClose(dev_no, (unsigned short)reset_f);
	if(rc > 0){
		switch(rc){
		case DEV_NOT_OPEN:
			printf("wfoCX͂nĂ܂\n");
			break;
		case DEV_ERR5:
			printf("foCXN[YG[\n");
			break;
		case MUTEX_ERR:
			printf("MUTEXJŃG[܂\n");
            break;
		default:
			printf("[Device Close] Other Error=%d\n",rc);
			break;
		}
	}
	else{
		printf("[Device Close] Device No.%d Close completed.\n",dev_no );
	}
    dev_no = 0xff;

}

//
//
//
void WriteCyc(void)
{
	unsigned int    data1,data2,i;
	unsigned short	*ptr,rc;


	// ̈P Writef[^͂
	printf("Enter CommonP Word-Data (Hex) ");
	scanf("%x", &data1);

	// ̈Q Writef[^͂
	printf("Enter Common 2 Word-Data (Hex) ");
	scanf("%x", &data2);

	ptr = (unsigned short *)&dsp_buf1[0];
	for(i=0 ; i<node_prm.cmn1_size ; i++){
		*ptr++ = (unsigned short)data1;
	}
	ptr = (unsigned short *)&dsp_buf2[0];
	for(i=0 ; i<node_prm.cmn2_size ; i++){
		*ptr++ = (unsigned short)data2;
	}

	rc = WriteCyclicALL(&dsp_buf1[0], &dsp_buf2[0], dev_no);

	if(rc > 0){
	    switch(rc){
	    case PRM_ERR:
		    printf("p^G[\n");
		    break;
	    case BUF_FUL:
		    printf("obt@ t\n");
		    break;
		case DEV_NOT_OPEN:
			printf("wfoCX͂nĂ܂\n");
			break;
		case MUTEX_ERR:
			printf("MUTEXrG[܂\n");
            break;
	    default:
		    printf("[WriteCyclicALL] Other Error=%d\n",rc);
		    break;
		}
	}

}
//
//
//
void WriteCyc_R(void)
{
	unsigned int    common, size, i;
	unsigned int    cmn_size, offset;
	unsigned int    data1;
	unsigned short  *ptr, rc;


	// ̈PÄQ̂ǂނH
	do {
		printf("ǂ̃R݂̈܂H\n");
		printf("1) ̈P\n");
		printf("2) ̈Q\n");
		printf("Enter number : ");
		scanf("%d", &common);
	} while (common < 1 || 2 < common);

	if(common==1){
		cmn_size = 512;
	}
	else{
		cmn_size = 8192;
	}

	// ΃AhX͂B
	while (1) {
		printf("݂Jn鑊΃AhX͂ĂiPʁF[hj: ");
		scanf("%d", &offset );
		if (offset > cmn_size) {
			printf("AhXR̈̃TCY傫łB\n");
		}
		else {
			break;
		}
	}

	// ǂݏo[h͂B
	while (1) {
		printf("ރ[h͂Ă : ");
		scanf("%d", &size);
		if (common == 1 && size > 512) {
			printf("傫܂B\n");
		}
		else if (common == 2 && size > 512 * 16) {
			printf("傫܂B\n");
		}
		else if (size <= 0) {
			printf("܂B\n");
		}
		else {
			break;
		}
	}

	//  Writef[^͂
	printf("Enter Common  Word-Data (Hex) ");
	scanf("%x", &data1);

	ptr = (unsigned short *)&dsp_buf2[0];
	for(i=0 ; i<size ; i++){
		*ptr++ = (unsigned short)data1;
	}

	rc = WriteCyclicRelative( (unsigned short)common, (unsigned short)offset, (unsigned short)size, &dsp_buf2[0], dev_no);

	switch(rc){
	case 0:
		break;
	case PRM_ERR:
		printf("p^G[\n");
		break;
	case BUF_FUL:
		printf("obt@ t\n");
		break;
	case DEV_NOT_OPEN:
		printf("wfoCX͂nĂ܂\n");
		break;
	case MUTEX_ERR:
		printf("MUTEXrG[܂\n");
        break;
	default:
		printf("[WriteCyclicRelative] Other Error=%d\n",rc);
		break;
	}
}
//
//
//
void ReadCyc_R(void)
{
	unsigned int   node, common, size, i;
	unsigned int   cmn_size, offset;
	unsigned short  rc;


	// m[hԍ͂B
	do {
		printf("Enter node number (1-254) : ");
		scanf("%d", &node);
	} while (node < 1 || 254 < node);

	// ̈PÄQ̂ǂǂݏoH
	do {
		printf("ǂ̃R̈ǂݏo܂H\n");
		printf("1) ̈P\n");
		printf("2) ̈Q\n");
		printf("Enter number : ");
		scanf("%d", &common);
	} while (common < 1 || 2 < common);

	if(common==1){
		cmn_size = 512;
	}
	else{
		cmn_size = 8192;
	}

	// ΃AhX͂B
	while (1) {
		printf("ǂݏoJn鑊΃AhX͂ĂiPʁF[hj: ");
		scanf("%d", &offset );
		printf("%d",offset);
		if (offset > cmn_size) {
			printf("AhXR̈̃TCY傫łB\n");
		}
		else {
			break;
		}
	}

	// ǂݏo[h͂B
	while (1) {
		printf("ǂݏo[h͂Ă : ");
		scanf("%d", &size);
		if (common == 1 && size > 512) {
			printf("傫܂B\n");
		}
		else if (common == 2 && size > 512 * 16) {
			printf("傫܂B\n");
		}
		else if (size <= 0) {
			printf("܂B\n");
		}
		else {
			break;
		}
	}
	for(i=0 ; i<size ; i++){
		dsp_buf2[i] = 0;
	}

	rc = ReadCyclicRelative( (unsigned short)node, (unsigned short)common, (unsigned short)offset, (unsigned short)size, &dsp_buf2[0], dev_no);

	switch(rc){
	case 0:
		for(i=0 ; i<size ; i++){
			printf("%hx ",dsp_buf2[i]);
		}
		break;
	case PRM_ERR:
		printf("p^G[\n");
		break;
	case NO_DATA:
		printf("wm[h̃f[^Ȃ\n");
		break;
	case OUT_RING:
		printf("m[hE\n");
		break;
	case DEV_NOT_OPEN:
		printf("wfoCX͂nĂ܂\n");
		break;
	case MUTEX_ERR:
		printf("MUTEXrG[܂\n");
        break;
	default:
		printf("[ReadCyclicRelative] Other Error=%d\n",rc);
		break;
	}
}
//
//
//
void ReadCyc_A(void)
{
 unsigned int		common, offset,  size, i;
 unsigned short		rc;


	// ̈PÄQ̂ǂǂݏoH
	do {
		printf("ǂ̃R̈ǂݏo܂H\n");
		printf("1) ̈P\n");
		printf("2) ̈Q\n");
		printf("Enter number : ");
		scanf("%d", &common);
	} while (common < 1 || 2 < common);

	// ΃AhX͂B
	printf("ǂݏoJn΃AhX͂ĂiPʁF[hj: ");
	scanf("%d", &offset );

	// ǂݏo[h͂B
	while (1) {
		printf("ǂݏo[h͂Ă : ");
		scanf("%d", &size);
		if (common == 1 && size > 512) {
			printf("傫܂B\n");
		}
		else if (common == 2 && size > 512 * 16) {
			printf("傫܂B\n");
		}
		else if (size <= 0) {
			printf("܂B\n");
		}
		else {
			break;
		}
	}

	rc = ReadCyclicAbsolute( (unsigned short)common, (unsigned short)offset, (unsigned short)size, &dsp_buf2[0], dev_no );
	switch(rc){
	case 0:
	    for(i=0 ; i<size ; i++){
		    printf("%hx ",dsp_buf2[i]);
		}
		break;
	case PRM_ERR:
		printf("p^G[\n");
		break;
	case DEV_NOT_OPEN:
		printf("wfoCX͂nĂ܂\n");
		break;
	case MUTEX_ERR:
		printf("MUTEXrG[܂\n");
        break;
	default:
		printf("[ReadCyclicRelative] Other Error=%d\n",rc);
		break;
	}
}
//
//
//
void ReadCyc_AL(void)
{
	unsigned int		node, i;
	unsigned short		rc;
	struct NodeInfo		node_prm;


	// m[hԍ͂B
	do {
		printf("Enter node number (1-254) : ");
		scanf("%d", &node);
	} while (node < 1 || 254 < node);

	rc = GetNodeInfo((unsigned short)node, &node_prm, dev_no);
	if(rc > 0){
		switch(rc){
		case TIM_OUT:
			printf("obh̃X|X ^CAEg\n");
			break;
		case PRM_ERR:
			printf("p^G[\n");
			break;
		case FATAL_ERR:
			printf("dG[\n");
			break;
		}
		return;
	}

    rc = ReadCyclicALL( (unsigned short)node, dsp_buf1, dsp_buf2, dev_no);

	switch(rc){
	case 0:
		printf("Common 1 = \n");
		for(i=0 ; i<node_prm.cmn1_size  ; i++){
			printf("%hx ",dsp_buf1[i]);
		}
		printf("\nCommon 2 = \n");
		for(i=0 ; i<node_prm.cmn2_size  ; i++){
			printf("%hx ",dsp_buf2[i]);
		}
		break;
	case PRM_ERR:
		printf("p^G[\n");
		break;
	case NO_DATA:
		printf("wm[h̃f[^Ȃ\n");
		break;
	case OUT_RING:
		printf("m[hE\n");
		break;
	case DEV_NOT_OPEN:
		printf("wfoCX͂nĂ܂\n");
		break;
	case MUTEX_ERR:
		printf("MUTEXrG[܂\n");
        break;
	default:
		printf("[ReadCyclicALL] Other Error=%d\n",rc);
		break;
	}

}

//
//
//
void RingInfo(void)
{
	struct SankaReqTable	sanka_prm,*ptr1;
	unsigned short			rc,i;


	rc = GetRingInfo(&sanka_prm, dev_no);

	if(rc > 0){
		switch(rc){
	    case PRM_ERR:
		    printf("p^G[\n");
		    break;
		case TIM_OUT:
			printf("obh̃X|X ^CAEg\n");
			break;
		case FATAL_ERR:
			printf("dG[\n");
			break;
	    case DEV_NOT_OPEN:
		    printf("wfoCX͂nĂ܂\n");
		    break;
	    case MUTEX_ERR:
		    printf("MUTEXrG[܂\n");
            break;
	    default:
		    printf("[GetRingInfo] Other Error=%d\n",rc);
		    break;
		}
		return;
	}

	// Qm[hmD\B
	ptr1 = &sanka_prm;
	if(ptr1->node_cnt == 0){
		printf("m[h͗EĂ܂B\n");
		return;
	}

	printf("\nQ̑m[h  ");
    for(i=0 ; i<ptr1->node_cnt ; i++){
		printf(" %d",ptr1->node_no[i]);
	}
	printf("\n");

}
//
//
//
void DspNodeInfo(void)
{
	struct NodeInfo		node_prm;
	unsigned int		node;
	unsigned short		rc;
	char                key[32];


	// m[hԍ͂B
	do {
		printf("Enter node number (1-254) : ");
		scanf("%d", &node);
	} while (node < 1 || 254 < node);
    printf("\n node=%d",node);

	rc = GetNodeInfo((unsigned short)node, &node_prm, dev_no);
	if(rc > 0){
		switch(rc){
		case PRM_ERR:
			printf("p^G[\n");
			break;
		case TIM_OUT:
			printf("obh̃X|X ^CAEg\n");
			break;
		case FATAL_ERR:
			printf("dG[\n");
			break;
	    case DEV_NOT_OPEN:
		    printf("wfoCX͂nĂ܂\n");
		    break;
	    case MUTEX_ERR:
		    printf("MUTEXrG[܂\n");
            break;
	    default:
		    printf("[GetNodeInfo] Other Error=%d\n",rc);
		    break;
		}
		return;
	}

	printf("m[hmD%d  \n",node);
	if(node_prm.sanka == 0){
		printf("Q^E  E\n");
	}
	else{
		printf("Q^E  Q\n");
		printf("Common 1 Address = %d\n",node_prm.cmn1_addr);
		printf("Common 1 Size    = %d\n",node_prm.cmn1_size);
		printf("Common 2 Address = %d\n",node_prm.cmn2_addr);
		printf("Common 2 Size    = %d\n",node_prm.cmn2_size);
		printf("RCT              = %d\n",node_prm.rct);
		printf("TW               = %d\n",node_prm.tw);
		printf("Link Status      = %xH\n",node_prm.link_status);
		if(node == my_node){
			printf("My Node Status   = %xH\n",node_prm.my_status);
		}
		printf("Vender           =%s\n",&node_prm.vender[0]);
		printf("Maker            =%s\n",&node_prm.maker[0]);
		printf("Node Name        =%s\n",&node_prm.name[0]);
	
		printf("Enter Any key(A->Z)");
	    do {
		   scanf("%c", key );
		} while (key[0] == 0x0a || key[0] == 0x0d);

		printf("\n");
	}
}
//
//
//
void DspNetInfo(void)
{
	unsigned short	rc;
	struct NetInfo	net_infp;


	rc = GetNetInfo(&net_infp, dev_no);
	if(rc > 0){
		switch(rc){
		case PRM_ERR:
			printf("p^G[\n");
			break;
		case TIM_OUT:
			printf("obh̃X|X ^CAEg\n");
			break;
		case FATAL_ERR:
			printf("dG[\n");
			break;
	    case DEV_NOT_OPEN:
		    printf("wfoCX͂nĂ܂\n");
		    break;
	    case MUTEX_ERR:
		    printf("MUTEXrG[܂\n");
            break;
	    default:
		    printf("[GetNetInfo] Other Error=%d\n",rc);
		    break;
		}
		return;
	}

	printf("RCT         = %d\n",net_infp.rct);
	printf("RC Current  = %d\n",net_infp.rcm);
	printf("RC Max      = %d\n",net_infp.rcm_max);
	printf("RC Min      = %d\n",net_infp.rcm_min);
	printf("Link Status = %x\n",net_infp.link_status);

}
//
//
//
void DspLogInfo(void)
{
	unsigned short	rc,i;


	rc = GetLogInfo(&log_buf[0], dev_no);
	if(rc > 0){
		switch(rc){
		case PRM_ERR:
			printf("p^G[\n");
			break;
		case TIM_OUT:
			printf("obh̃X|X ^CAEg\n");
			break;
		case FATAL_ERR:
			printf("dG[\n");
			break;
	    case DEV_NOT_OPEN:
		    printf("wfoCX͂nĂ܂\n");
		    break;
	    case MUTEX_ERR:
		    printf("MUTEXrG[܂\n");
            break;
	    default:
		    printf("[GetLogInfo] Other Error=%d\n",rc);
		    break;
		}
		return;
	}

	for(i=0 ; i<128 ; i++){
		if (log_buf[i] == 0){
			printf("%x ", log_buf[i]);
		}
		else{
			printf("%x offset = %d ", log_buf[i], i*4);
		}
	}

}
//
//
//
void UplStatus(void)
{
	unsigned short	rc;
	unsigned int	status;


	// ʑwXe[^X͂Bv
	printf("ʑwXe[^X͂ĂiHex/Wordj: ");
	scanf("%x", &status );

	rc = SetUplStatus((unsigned short)status, dev_no);
	switch(rc){
	case 0:
		printf("I܂\n");
		break;
	case PRM_ERR:
		printf("p^G[\n");
		break;
	case TIM_OUT:
		printf("obh̃X|X ^CAEg\n");
		break;
	case FATAL_ERR:
		printf("dG[\n");
		break;
    case DEV_NOT_OPEN:
	    printf("wfoCX͂nĂ܂\n");
	    break;
    case MUTEX_ERR:
	    printf("MUTEXrG[܂\n");
        break;
	default:
	    printf("[SetUplStatus] Other Error=%d\n",rc);
	    break;
	}

}

//
//
//
void DspFatalErr(void)
{
	struct ErrInfo err_infp,*ptr;
	unsigned short rc;


	rc = GetErrInfo(&err_infp, dev_no);
	switch(rc){
	case 0:
		printf("I܂\n");
		break;
	case PRM_ERR:
		printf("p^G[\n");
		break;
    case DEV_NOT_OPEN:
	    printf("wfoCX͂nĂ܂\n");
	    break;
	}

	ptr = &err_infp;
	printf("Error Code = %xH",ptr->err_code);
	printf(" Error Lngth = %d",ptr->length);
	printf(" Error Message = %s",&ptr->err_msg[0]);

}
//
//
//
void MsgSendReceive(void)
{
	unsigned int number;


	while (1) {
		printf("\n********** Message Menue *************\n");
		printf("1)  Message Send\n");
		printf("2)  Check Message End\n");
		printf("3)  Read Message\n");
		printf("4)  Loop Back Test\n");
		printf("6) I\n");
		printf("Enter number : ");
		scanf("%d", &number);
		switch(number){
		case 1:
			WriteMsg(dev_no);
			break;
		case 2:
			CheckMsg(dev_no);
			break;
		case 3:
			ReadMsg(dev_no);
			break;
		case 4:
			MessageLoopBack(dev_no);
			break;
		case 6:
			printf("\n");
			return;
		default:
			break;
		}
	}

}
//
//
//
void WriteMsg(unsigned short dev_no)
{
	unsigned int			node;
	unsigned int			wait_flg,msg_no;
	unsigned short			rc;
	struct MessageInfo  	msg_prm;

	// m[hԍ͂B
	do {
		printf("Mm[hmDw肵Ă(1-254) : ");
		scanf("%d", &node);
	} while (node < 1 || 254 < node);

	msg_prm.msg_node     = (unsigned char)node;
	msg_prm.msg_bc       = 0; 
	msg_prm.msg_result   = 0; 
	msg_prm.msg_adr      = 0; 
	msg_prm.msg_lng      = 0; 

	// sbc͂B
	do {
		printf("ǂ̃bZ[W𑗂܂\n");
		printf("1)  ONA v\n");
		printf("2)  O[h v\n");
		printf("3)  lbg[Np^[h v\n");
		printf("Enter number : ");
		scanf("%d", &msg_no);
	} while (msg_no < 1 || 3 < msg_no);
	switch(msg_no){
	case 1:
		msg_prm.msg_tcd = LGC_REQ; 
		break;
	case 2:
		msg_prm.msg_tcd = LGR_REQ; 
		break;
	case 3:
		msg_prm.msg_tcd = NTR_REQ; 
		break;
	default:
		break;
	}

	// I҂ [hI
	do {
		printf("bZ[WM I҂܂H\n");
		printf("1) I҂Ȃ\n");
		printf("2) I҂\n");
		printf("Enter number : ");
		scanf("%d", &wait_flg);
	} while (wait_flg < 1 || 2 < wait_flg);

	wait_flg -= 1;

	rc = WriteMessage(&msg_prm, &msg_buf[0], (unsigned short)wait_flg, dev_no);

	switch(rc){
	case 0:
		printf("bZ[WMv͐I܂\n");
		break;
	case PRM_ERR:
		printf("p^G[\n");
		break;
	case TIM_OUT:
		printf("obh̃X|X ^CAEg\n");
		break;
	case BUF_FUL:
		printf("obt@ t\n");
		break;
	case TX_FAIL:
		printf("Ms\n");
		break;
    case OUT_RING:
	    printf("m[hE\n");
	    break;
	case FATAL_ERR:
		printf("dG[\n");
		break;
    case DEV_NOT_OPEN:
	    printf("wfoCX͂nĂ܂\n");
	    break;
    case MUTEX_ERR:
	    printf("MUTEXrG[܂\n");
        break;
	default:
	   printf("[WriteMessage] Other Error=%d\n",rc);
	   break;
	}

}
//
//
//
void CheckMsg(unsigned short dev_no)
{
	unsigned short		rc;
	unsigned short		node,tcd;

	rc = CheckMessageEnd(&node, &tcd, dev_no);

	if(rc >= 0){
		switch(rc){
		case 0:
			printf("bZ[WI܂ (node=%d) (TCD=%xH)\n",node,tcd);
			break;
	    case PRM_ERR:
		    printf("p^G[\n");
		    break;
		case TX_FAIL:
			printf("Ms\n");
			break;
		case TX_NOT_END:
			printf("M\n");
			break;
		case FATAL_ERR:
			printf("dG[\n");
			break;
        case DEV_NOT_OPEN:
	        printf("wfoCX͂nĂ܂\n");
	        break;
        case MUTEX_ERR:
	        printf("MUTEXrG[܂\n");
            break;
		default:
			printf("`X|X\n=%d",rc);
			break;

		}
	}


}
//
//
//
void ReadMsg(unsigned short dev_no)
{
	struct MessageInfo  	rcv_msg;
	unsigned int			wait_flg;
	unsigned short			rc,i;


	// I҂ [hI
	do {
		printf("bZ[WM I҂܂H\n");
		printf("1) I҂Ȃ\n");
		printf("2) I҂\n");
		printf("Enter number : ");
		scanf("%d", &wait_flg);
	} while (wait_flg < 1 || 2 < wait_flg);
	wait_flg -= 1;

	rc = ReadMessage(&rcv_msg,&msg_buf[0],(unsigned short)wait_flg,dev_no);

	if(rc > 0){
		switch(rc){
	    case PRM_ERR:
		    printf("p^G[\n");
		    break;
		case NO_DATA:
			printf("Mf[^Ȃ\n");
			break;
		case TIM_OUT:
			printf("obh̃X|X ^CAEg\n");
			break;
		case FATAL_ERR:
			printf("dG[\n");
			break;
        case DEV_NOT_OPEN:
	        printf("wfoCX͂nĂ܂\n");
	        break;
        case MUTEX_ERR:
	        printf("MUTEXrG[܂\n");
            break;
	    default:
	        printf("[ReadMessage] Other Error=%d\n",rc);
	        break;
		}
		return;
	}

	printf("Mf[^\\n");
	printf("node No. = %d\n",rcv_msg.msg_node);
	printf("result   = %d\n",rcv_msg.msg_result);
	printf("tcd      = %xH\n",rcv_msg.msg_tcd);
	printf("bc       = %d\n",rcv_msg.msg_bc);
	for(i=0 ; i<rcv_msg.msg_bc ; i++){
		printf("%x ",msg_buf[i]);
	}

}

//
// bZ[W܂Ԃ 
// 
void MessageLoopBack(unsigned short dev_no)
{
	struct	MessageInfo *snd_ptr;
	struct	MessageInfo *rcv_ptr;
	struct  SankaReqTable sanka_ptr;
	unsigned int		loop_cnt;
	unsigned int		node_cnt,i,j;
	unsigned char		dat,err_f,*d_p;
	unsigned short		rc, chk_node, chk_tcd;
	unsigned int		wait_flg, tmp_i;

	msnd_cnt = 0;
	mrcv_cnt = 0;
	msnd_st_pnt = 0;
	msnd_tx_pnt = 0;
	mrcv_st_pnt = 0;
	mrcv_tx_pnt = 0;

	// bZ[W܂Ԃv bZ[W𐶐B
    snd_ptr = &msnd_tbl[msnd_st_pnt];
	do{
		printf("m[hmDw肵ĂiQ-->254j\n");
		scanf("%d", &tmp_i);
	}while(tmp_i<2 || tmp_i>254);

	snd_ptr->msg_node = (unsigned char)tmp_i; 

	do{
		printf("f[^oCgw肵Ăi 0-->1024)\n");
		scanf("%d", &tmp_i);
	}while(tmp_i>1024);

	// I҂ [hI
	do {
		printf("bZ[WM I҂܂H\n");
		printf("1) I҂Ȃ\n");
		printf("2) I҂\n");
		printf("Enter number : ");
		scanf("%d", &wait_flg);
	} while (wait_flg < 1 || 2 < wait_flg);
	wait_flg -= 1;

	snd_ptr->msg_bc     = (unsigned short)tmp_i; 
    snd_ptr->msg_result = 0;
    snd_ptr->msg_lng  = 0;
    snd_ptr->msg_adr   = 0;
    snd_ptr->msg_tcd    = LPB_REQ;

    // ܂Ԃf[^CNgf[^ŃNAB
	dat = 0;
	d_p = &msnd_buf[msnd_st_pnt][0];
	for(i=0 ; i<tmp_i ; i++){
		*d_p++ = dat;
		dat++;
	}
	msnd_st_pnt+=1;
	msnd_cnt+=1;

	// Broad Cast̏ꍇAQ̑m[h𒲂ׂ
	if(snd_ptr->msg_node == 255){

		// Qm[hvR}hZbgB
		rc = GetRingInfo(&sanka_ptr, dev_no);
		if(rc > 0){
			switch(rc){
			case TIM_OUT:
				printf("obh̃X|X ^CAEg\n");
				break;
			case FATAL_ERR:
				printf("dG[\n");
				break;
	        default:
	            printf("[GetRingInfo] Other Error=%d\n",rc);
	            break;
			}
			return;
		}

		// m[h𓾂
		node_cnt = sanka_ptr.node_cnt;

	}
	// 1:1bZ[ŴƂ́Am[hPŒ
	else{
		node_cnt = 1;
	}

	loop_cnt = 0;
	err_f = 0;
    for( ; ; ){
		// bZ[W𑗐M
		if(msnd_cnt > 0){
			rc = WriteMessage(&msnd_tbl[msnd_tx_pnt], &msnd_buf[msnd_tx_pnt][0], (unsigned short)wait_flg, dev_no);
			if(rc == 0){
				msnd_cnt -= 1;
				msnd_tx_pnt += 1;
				if(msnd_tx_pnt == MSG_SND_MAX){
					msnd_tx_pnt = 0;
				}
			}
			else{
				// G[̎͏IAobt@t̎́AgCB
				if(rc != BUF_FUL){
					printf("bZ[WM v G[܂B\n");
					err_f = 1;
					break;
				}
			}
		}
		rc = CheckMessageEnd(&chk_node, &chk_tcd, dev_no);
		if(rc == 0){
			printf("bZ[WMI܂B\n");
		}
		else{
			if(rc != TX_NOT_END){
				printf("bZ[WM G[܂B\n");
				err_f = 1;
				break;
			}
		}
		rc = ReadMessage(&mrcv_tbl[mrcv_st_pnt], &mrcv_buf[mrcv_st_pnt][0], (unsigned short)wait_flg, dev_no);
		if(rc == 0){
			printf("bZ[WMI܂B\n");
			mrcv_cnt += 1;
			mrcv_st_pnt += 1;
			if(mrcv_st_pnt == MSG_RCV_MAX){
				mrcv_st_pnt = 0;
			}
		}
		else{
			if( rc != NO_DATA ){
				printf("bZ[WM G[܂B\n");
				err_f = 1;
				break;
			}
		}

		// I`FbN
		if(mrcv_cnt == node_cnt){    // I
			printf("SẴbZ[WM𐳏I܂\n");
			break;
		}
		else{
			loop_cnt +=1;
			if(loop_cnt == 0xfffffff){
				printf("^CAEgłBI܂B\n");
				err_f = 1;
			}
		}
		if(err_f == 1){   // ُI
			break;
		}
	}
	if(err_f == 1){
		switch(rc){
			case PRM_ERR:
				printf("p^G[\n");
				break;
			case TIM_OUT:
				printf("obh̃X|X ^CAEg\n");
				break;
			case BUF_FUL:
				printf("obt@ t\n");
				break;
			case TX_FAIL:
				printf("Ms\n");
				break;
			case FATAL_ERR:
				printf("dG[\n");
				break;
	        case OUT_RING:
		        printf("m[hE\n");
		        break;
			default:
				printf("`X|X\n=%d",rc);
				break;
			}
		return;
	}

	// MbZ[W f[^̃`FbNs
	if(err_f == 0){
		for(j=0 ; j<mrcv_cnt ; j++){
			rcv_ptr = &mrcv_tbl[j]; 
			d_p = &mrcv_buf[j][0];
			dat = 0;
			err_f = 0;
			for(i=0 ; i<rcv_ptr->msg_bc ; i++){
				if(*d_p != dat){
					err_f = 1;
					break;
				}
				d_p++;
				dat++;
			}
			if(err_f == 1){	printf("܂Ԃf[^r sv  m[hmD %d\n",rcv_ptr->msg_node);
							printf("rcv=%d snd=%d\n",*d_p,dat);
			}
			else			printf("܂Ԃf[^r     m[hmD %d\n",rcv_ptr->msg_node);
		}
	}

	printf("\n");

}

//
// ULS  LKS̕\
//
void UlsLks()
{
struct UlsInfo	uls_info,*uls_p;

	unsigned short	rc,i;


	rc = ReadUls_All(&uls_info, dev_no);
	if(rc > 0){
		switch(rc){
		case TIM_OUT:
			printf("obh̃X|X ^CAEg\n");
			break;
		case FATAL_ERR:
			printf("dG[\n");
			break;
	    default:
	        printf("[ReadUls_All] Other Error=%d\n",rc);
	        break;
		}
		return;
	}

	uls_p = &uls_info;
	for(i=0 ; i<254 ; i++){
        if( (uls_p->lks[i] & 0x01) == 1 ){    /* Q */
		   printf("\n[Node %d] ULS=%x LKS=%x ",i+1,uls_p->uls[i],uls_p->lks[i]&0xfe);
		}
	}
	printf("\n");

}

void AllCycUls(void)
{
   unsigned short		rc;
   unsigned int		c1_adr, c1_siz, c2_adr, c2_siz, i;
   struct UlsInfo	    uls_info,*uls_p;

	// foCXmD͂B
	do {
		printf("foCXmDw肵ĂiDecj\n");
		scanf("%d", &dev_no);
	} while ( 4 <= dev_no );


	// ΃AhX͂B
	printf("RP̐΃AhX͂ĂiPʁF[hj: ");
	scanf("%d", &c1_adr );

	// ǂݏo[h͂B
	while (1) {
		printf("RP̓ǂݏo[h͂Ă : ");
		scanf("%d", &c1_siz);
		if (c1_siz > 512) {
			printf("傫܂B\n");
		}
		else if (c1_siz < 0) {
			printf("܂B\n");
		}
		else {
			break;
		}
	}
	// ΃AhX͂B
	printf("RQ̐΃AhX͂ĂiPʁF[hj: ");
	scanf("%d", &c2_adr );

	// ǂݏo[h͂B
	while (1) {
		printf("RQ̓ǂݏo[h͂Ă : ");
		scanf("%d", &c2_siz);
		if (c2_siz > 512 * 16) {
			printf("傫܂B\n");
		}
		else if (c2_siz < 0) {
			printf("܂B\n");
		}
		else {
			break;
		}
	}
	rc = ReadCycAbsUls( (unsigned short)c1_adr, (unsigned short)c1_siz, (unsigned short)c2_adr, (unsigned short)c2_siz, &dsp_buf1[0], &dsp_buf2[0], &uls_info, dev_no );

	for(i=0 ; i<c1_siz ; i++){
		printf("%hx ",dsp_buf1[i]);
	}
	for(i=0 ; i<c2_siz ; i++){
		printf("%hx ",dsp_buf2[i]);
	}

	if(rc > 0){
		switch(rc){
		case TIM_OUT:
			printf("obh̃X|X ^CAEg\n");
			break;
		case FATAL_ERR:
			printf("dG[\n");
			break;
		}
		return;
	}

	uls_p = &uls_info;
	for(i=0 ; i<254 ; i++){
        if( (uls_p->lks[i] & 0x01) == 1 ){    /* Q */
		   printf("\n[Node %d] ULS=%x LKS=%x ",i+1,uls_p->uls[i],uls_p->lks[i]&0xfe);
		}
	}

}

void Firmware_ver_dsp()
{
    unsigned short fversion, rc;
	unsigned short ver_hi, ver_low;
	unsigned short dev_no;


	// foCXmD͂B
	do {
		printf("foCXmDw肵ĂiDecj\n");
		scanf("%x", &dev_no);
	} while (0 > dev_no || 4 <= dev_no);


	rc = Firmware_Version(&fversion, dev_no);

	switch(rc){
	case 0:
		break;
	case PRM_ERR:
		printf("p^G[\n");
		return;
	case TIM_OUT:
        //FLPCI Ver47(FL-net Ver1)ȑÕt@[EFA̓^CAEgŏI
		printf("\nUnknown Version");
		return;
	case FATAL_ERR:
		printf("dG[\n");
		return;
    case DEV_NOT_OPEN:
	    printf("wfoCX͂nĂ܂\n");
	    return;
    case MUTEX_ERR:
	    printf("MUTEXrG[܂\n");
        return;
	default:
	    printf("[Firmware_ver_dsp] Other Error=%d\n",rc);
	    return;
	}

	ver_low = fversion & 0xff;
	ver_hi  = (fversion & 0xff00) >> 8; 
	if(ver_hi == 20){      /* FL-PCI/v2-100 */
		printf("\nFirmware Version = %02d%02d\n", ver_hi, ver_low );
	}
	else{                  /* FL-PCI/v2 */
		if(ver_low > 0){
			printf("\nFirmware Version = %02d%02d\n", ver_hi, ver_low );
		}
		else{
			//FLPCI Ver1004(FL-net Ver2)ȑÕt@[EFAver_low=0Œlʒm
			printf("\nUnknown Version");
		}
	}

}
/* 100Mbps support 06/03/26 */
void DspEtherMode()
{
unsigned short rc;
unsigned long speed, duplex;

	rc = Get_Speed( &speed, &duplex, dev_no );
	if(rc > 0){
		switch(rc){
	    case PRM_ERR:
		    printf("p^G[\n");
		    break;
		case NO_DATA:
			printf("Mf[^Ȃ\n");
			break;
		case TIM_OUT:
			printf("obh̃X|X ^CAEg\n");
			break;
		case FATAL_ERR:
			printf("dG[\n");
			break;
        case DEV_NOT_OPEN:
	        printf("wfoCX͂nĂ܂\n");
	        break;
        case MUTEX_ERR:
	        printf("MUTEXrG[܂\n");
            break;
		case LNK_DOWN:
	        printf("P[uOĂ邽ߑxݒ͖ł\n");
			break;
	    default:
	        printf("[Get_Speed] Other Error=%d\n",rc);
	        break;
		}
		return;
	}
	if(speed == 0){
		if(duplex == 0){
			printf("ʐMx̐ݒ 10Mbps 2dł\n");
		}
		else{
			printf("ʐMx̐ݒ 10Mbps S2dł\n");
		}
	}
	else{
		if(duplex == 0){
			printf("ʐMx̐ݒ 100Mbps 2dł\n");
		}
		else{
			printf("ʐMx̐ݒ 100Mbps S2dł\n");
		}
    }
	return;
	
}

