Option Strict Off
Option Explicit On 
Imports System
Imports System.Runtime.InteropService


Module Module1
    '----------- Msg TCD Code
    Public Const BBR_REQ As Integer = 65003
    Public Const BBW_REQ As Integer = 65004
    Public Const BWR_REQ As Integer = 65005
    Public Const BWW_REQ As Integer = 65006
    Public Const NTR_REQ As Integer = 65007
    Public Const NTW_REQ As Integer = 65008
    Public Const STP_REQ As Integer = 65009
    Public Const RUN_REQ As Integer = 65010
    Public Const PFR_REQ As Integer = 65011
    Public Const LGR_REQ As Integer = 65013
    Public Const LGC_REQ As Integer = 65014
    Public Const LPB_REQ As Integer = 65015

    Public Const BBR_RSP As Integer = 65203
    Public Const BBW_RSP As Integer = 65204
    Public Const BWR_RSP As Integer = 65205
    Public Const BWW_RSP As Integer = 65206
    Public Const NTR_RSP As Integer = 65207
    Public Const NTW_RSP As Integer = 65208
    Public Const STP_RSP As Integer = 65209
    Public Const RUN_RSP As Integer = 65210
    Public Const PFR_RSP As Integer = 65211
    Public Const LGR_RSP As Integer = 65213
    Public Const LGC_RSP As Integer = 65214
    Public Const LPB_RSP As Integer = 65215

    Public Const THR_MSG_MAX As Integer = 59999

    Public hDevice0 As Integer
    Public lBdno As Integer
    Public dev_no As Short

    '///////////////////////////////
    'AvP[V O[oϐ
    '///////////////////////////////

    Public my_node As Short
    Public c1_adr As Short
    Public c1_siz As Short
    Public c2_adr As Short
    Public c2_siz As Short

    Public msgsnd As MsgData
    Public msgrcv As MsgData
    Public msg_prm As MessageInfo

    '////////////////////////////////////////////
    '// tH[\`
    '////////////////////////////////////////////
    Public Init_dsp As Initialize
    Public NodInf_dsp As NodInf
    Public LogInf_dsp As LogInf
    Public MsgEnt_dsp As MsgEnt
    Public MsgReceive_dsp As MsgReceive
    Public UplSts_dsp As UplSts
    Public prm_dsp As net_prm

    '////////////////////////////////////////////
    '// p̕ϐ
    '/////////////////////////////////////////////
    Public printFont As Font
    Public printPosition As Integer
    Public printText As String


    '/////////////////////////////////////////////
    '// Library ֐ AvP[VI/F \
    '/////////////////////////////////////////////
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> Structure CmnStruct
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=512)> Public common1_buf() As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=512 * 16)> Public common2_buf() As Short

        Public Sub Initialize()
            ReDim common1_buf(511)
            ReDim common2_buf(512 * 16 - 1)
        End Sub
    End Structure

    '// Qm[hvR}h\
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> Structure SankaReqTable
        Public node_cnt As Byte 'Qm[h
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=255)> Public node_no() As Byte 'Qm[hmD

        Public Sub Initialize()
            ReDim node_no(254)
        End Sub
    End Structure

    '// lbg[NR}h\
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> Structure NetInfo
        Public rct As Short 'tbVTCN ݒl
        Public rcm As Short 'tbVTCN li݁j
        Public rcm_max As Short 'tbVTCN liőj
        Public rcm_min As Short 'tbVTCN liŏj
        Public link_status As Byte 'N̏
    End Structure

    '// dG[R}h \
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> Structure ErrInfo
        Public err_code As Short 'G[R[h
        Public length As Short 'bZ[W
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=128)> Public err_msg() As Byte 'G[bZ[W 128Byte

        Public Sub Initialize()
            ReDim err_msg(127)
        End Sub
    End Structure

    '//  p^\
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> Structure InitInfo
        Public ip_adr As Integer  'm[hhoAhX
        Public dev_no As Short  'foCXNo.
        Public cmn1_adr As Short 'R ̈P AhX
        Public cmn1_size As Short 'R ̈P TCY
        Public cmn2_adr As Short 'R ̈Q AhX
        Public cmn2_size As Short 'R ̈Q TCY
        Public tw As Byte 'g[NĎ^CAEgl
        Public mft As Byte 'ŏt[Ԋu
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=11)> Public vender() As Byte    'x_ 11Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=11)> Public maker() As Byte  '[J[ 11Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=11)> Public node_name() As Byte  'm[h 11Byte

        Public Sub Initialize()
            ReDim vender(10)
            ReDim maker(10)
            ReDim node_name(10)
        End Sub
    End Structure

    '// m[hv \
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> Structure NodeInfo
        Public sanka As Byte 'Q^E tO
        Public dummy1 As Byte
        Public uls As Short 'ʑwXe[^X
        Public cmn1_addr As Short 'R̈PAhX
        Public cmn1_size As Short 'R̈PTCY
        Public cmn2_addr As Short 'R̈QAhX
        Public cmn2_size As Short 'R̈QTCY
        Public rct As Short 'tbVTCNe
        Public tw As Byte 'g[NĎ
        Public mft As Byte 'ŏt[Ԋu
        Public link_status As Byte 'N̏
        Public my_status As Byte 'm[h̏
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=11)> Public vender() As Byte 'x_[
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=11)> Public maker() As Byte '[J[
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=11)> Public node_name() As Byte 'm[h
        Public dummy2 As Byte

        Public Sub Initialize()
            ReDim vender(10)
            ReDim maker(10)
            ReDim node_name(10)
        End Sub
    End Structure


    '// bZ[WM \
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> Structure MessageInfo
        Public msg_node As Byte 'm[hԍ(1`254)
        Public msg_result As Byte 'ʃR[h
        Public msg_tcd As Integer 'gUNVR[h
        Public msg_bc As Short 'bZ[Wf[^oCg
        Public msg_adr As Integer 'zAhX AhX
        Public msg_lng As Short 'zAhX f[^
    End Structure

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> Structure LogInfo
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=128)> Public Log_buf() As Integer 'LOG Buffer 128Byte

        Public Sub Initialize()
            ReDim Log_buf(127)
        End Sub
    End Structure

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> Structure MsgData
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=1024)> Public msg_buf() As Byte 'Message Buffer 1024Byte

        Public Sub Initialize()
            ReDim msg_buf(1023)
        End Sub
    End Structure

    '// Sm[h(ULS & LKS)
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> Structure UlsLks
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=254)> Public uls() As Short 'ʑwXe[^X 254
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=254)> Public lks() As Byte 'NXe[^X 254

        Public Sub Initialize()
            ReDim uls(253)
            ReDim lks(253)
        End Sub
    End Structure


    '/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '// Visual Basic Application FL-netCu֐Ăяo߂ɂ́A܂Å֐ĂяoƂ錾Ȃ΂Ȃ܂B
    '// Declare Function ֐@Lib "flpci_mul" Alias "APIi@A........ ) As ߂ľ^
    '// ̌^A߂ľ^́AĈ̂ΉVBǍ^ɏ܂B
    '// DeclareXe[gg̏ڍׂ́ALURLɒ`Ă܂B
    '// https://msdn.microsoft.com/ja-jp/library/cs376178.aspx
    '// https://msdn.microsoft.com/ja-jp/library/4zey12w5.aspx
    '/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    Declare Function FL_Initialize Lib "flpci_mul" Alias "_FL_Initialize@4" (ByRef init_prm As InitInfo) As Short
    Declare Function WriteCyclic_ALL Lib "flpci_mul" Alias "_WriteCyclic_ALL@8" (ByRef flbuf As CmnStruct, ByVal dev_no As Short) As Short
    Declare Function WriteCyclic_Rel Lib "flpci_mul" Alias "_WriteCyclic_Rel@20" (ByVal comn As Short, ByVal rel_adr As Short, ByVal size As Short, ByRef flbuf As CmnStruct, ByVal dev_no As Short) As Short
    Declare Function ReadCyclic_Rel Lib "flpci_mul" Alias "_ReadCyclic_Rel@24" (ByVal node As Short, ByVal comn As Short, ByVal rel_adr As Short, ByVal size As Short, ByRef flbuf As CmnStruct, ByVal dev_no As Short) As Short
    Declare Function ReadCyclic_Abs Lib "flpci_mul" Alias "_ReadCyclic_Abs@20" (ByVal comn As Short, ByVal abs_adr As Short, ByVal size As Short, ByRef flbuf As CmnStruct, ByVal dev_no As Short) As Short
    Declare Function ReadCyclic_ALL Lib "flpci_mul" Alias "_ReadCyclic_ALL@12" (ByVal node As Short, ByRef flbuf As CmnStruct, ByVal dev_no As Short) As Short
    Declare Function WriteMessage Lib "flpci_mul" Alias "_WriteMessage@16" (ByRef msg_prm As MessageInfo, ByRef msgbuf As MsgData, ByVal wait_flg As Short, ByVal dev_no As Short) As Short
    Declare Function CheckMessageEnd Lib "flpci_mul" Alias "_CheckMessageEnd@12" (ByRef node As Short, ByRef tcd As Short, ByVal dev_no As Short) As Short
    Declare Function ReadMessage Lib "flpci_mul" Alias "_ReadMessage@16" (ByRef msg_prm As MessageInfo, ByRef msgbuf As MsgData, ByVal wait_flg As Short, ByVal dev_no As Short) As Short
    Declare Function GetRingInfo Lib "flpci_mul" Alias "_GetRingInfo@8" (ByRef sanka_tbl As SankaReqTable, ByVal dev_no As Short) As Short
    Declare Function GetNodeInfo Lib "flpci_mul" Alias "_GetNodeInfo@12" (ByVal node As Short, ByRef node_tbl As NodeInfo, ByVal dev_no As Short) As Short
    Declare Function GetNetInfo Lib "flpci_mul" Alias "_GetNetInfo@8" (ByRef net_tbl As NetInfo, ByVal dev_no As Short) As Short
    Declare Function GetLogInfo Lib "flpci_mul" Alias "_GetLogInfo@8" (ByRef logbuf As LogInfo, ByVal dev_no As Short) As Short
    Declare Function SetUplStatus Lib "flpci_mul" Alias "_SetUplStatus@8" (ByVal uplstatus As Short, ByVal dev_no As Short) As Short
    Declare Function GetErrInfo Lib "flpci_mul" Alias "_GetErrInfo@8" (ByRef err_tbl As ErrInfo, ByVal dev_no As Short) As Short
    Declare Function DeviceClose Lib "flpci_mul" Alias "_DeviceClose@8" (ByVal dev_no As Short, ByVal reset_f As Short) As Short
    Declare Function DeviceOpen Lib "flpci_mul" Alias "_DeviceOpen@4" (ByVal dev_no As Short) As Short
    Declare Function ReadUls_All Lib "flpci_mul" Alias "_ReadUls_All@8" (ByRef uls_info As UlsLks, ByVal dev_no As Short) As Short
    Declare Function Dll_Version Lib "flpci_mul" Alias "_Dll_Version@0" () As Short
    Declare Function Firmware_Version Lib "flpci_mul" Alias "_Firmware_Version@8" (ByRef version As Short, ByVal dev_no As Short) As Short
    Declare Function Set_Speed Lib "flpci_mul" Alias "_Set_Speed@8" (ByVal speed As Integer, ByVal dev_no As Short) As Short                             ' 100Mbps 06/03/26 
    Declare Function Get_Speed Lib "flpci_mul" Alias "_Get_Speed@12" (ByRef speed As Integer, ByRef duplex As Integer, ByVal dev_no As Short) As Short   ' 100Mbps 06/03/26



    '////////////////////////
    ' dG[\
    '////////////////////////
    Public Sub F_err_dsp()

        Dim r As Short
        Dim cnt As Short
        Dim temp1 As String
        Dim err_prm As ErrInfo

        err_prm.Initialize()

        r = GetErrInfo(err_prm, dev_no)
        Select Case r
            Case 0
                MsgBox("Error Information Normal End")
            Case 14
                MsgBox("Device Not Open")
        End Select


        temp1 = "dG[" & Hex(err_prm.err_code) & " "
        If err_prm.length > 0 Then
            cnt = 0
            Do Until cnt = err_prm.length
                temp1 = temp1 & Chr(err_prm.err_msg(cnt))
                cnt = cnt + 1
            Loop
        End If

        MsgBox(temp1)

    End Sub
    '///////////////////////////////////////////////////
    '//@v^o͊֐
    '///////////////////////////////////////////////////
    Public Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
        ' sL"\n"ɓꂷ
        If printPosition = 0 Then
            printText = printText.Replace(vbCrLf, vbLf)
            printText = printText.Replace(vbCr, vbLf)
        End If
        '鏉ʒuݒ
        Dim x As Integer = e.MarginBounds.Left
        Dim y As Integer = e.MarginBounds.Top

        'Py[WɎ܂ȂA镶ȂȂ܂Ń[v
        While e.MarginBounds.Height > y + printFont.Height AndAlso printPosition < printText.Length
            Dim line As String = ""
            While True
                If printPosition >= printText.Length OrElse printText.Chars(printPosition) = vbLf Then
                    printPosition += 1
                    Exit While
                End If
                'PǉA𒴂邩ׂ
                line += printText.Chars(printPosition)
                If e.Graphics.MeasureString(line, printFont).Width > e.MarginBounds.Width Then
                    '܂Ԃ
                    line = line.Substring(0, line.Length - 1)
                    Exit While
                End If
                printPosition += 1
            End While
            e.Graphics.DrawString(line, printFont, Brushes.Black, x, y)
            '̍s̈ʒuvZ
            y += printFont.GetHeight(e.Graphics)
        End While

        '̃y[W邩ׂ
        If printPosition >= printText.Length Then
            e.HasMorePages = False
            printPosition = 0  '
        Else
            e.HasMorePages = True
        End If
    End Sub

End Module